/*
** Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
** See the file "LICENSE" at the top of the source distribution for
** full license terms.
**
** NOTICE: This file was generated by the tools of the Erlang Driver
**         toolkit.  Do not edit this file by hand unless you know
**         what you're doing!
**
*/

#ifndef __BERKELEY_DB_DRV_H
#define __BERKELEY_DB_DRV_H

#ifdef   DRIVER_USING_PTHREADS
#include <pthread.h>
#endif   /* DRIVER_USING_PTHREADS */

/*
** Driver<->emulator communication codes (xref with top of berkeley_db_drv.hrl)
*/

#define _DEBUG                          0
#define _NULL                           1
#define _ENV_CREATE                     2
#define _ENV_CLOSE                      3
#define _ENV_OPEN                       4
#define _ENV_REMOVE                     5
#define _ENV_SET_DATA_DIR               6
#define _ENV_SET_ERRFILE                7
#define _ENV_SET_ERRPFX                 8
#define _ENV_SET_FLAGS                  9
#define _ENV_SET_RPC_SERVER             10
#define _ENV_SET_SHM_KEY                11
#define _ENV_SET_TAS_SPINS              12
#define _ENV_SET_TMP_DIR                13
#define _ENV_SET_TIMEOUT                14
#define _ENV_SET_VERBOSE                15
#define _DB_STRERROR                    16
#define _DB_VERSION                     17
#define _DB_CREATE                      18
#define _DB_CLOSE                       19
#define _DB_DEL                         20
#define _DB_FD                          21
#define _DB_GET                         22
#define _DB_GET_BYTESWAPPED             23
#define _DB_GET_TYPE                    24
#define _DB_OPEN                        25
#define _DB_PUT                         26
#define _DB_REMOVE                      27
#define _DB_RENAME                      28
#define _DB_SYNC                        29
#define _DB_TRUNCATE                    30
#define _DB_UPGRADE                     31
#define _DB_VERIFY                      32
#define _DB_SET_CACHESIZE               33
#define _DB_SET_ERRFILE                 34
#define _DB_SET_ERRPFX                  35
#define _DB_SET_FLAGS                   36
#define _DB_SET_PAGESIZE                37
#define _DB_SET_BT_MINKEY               38
#define _DB_SET_RE_DELIM                39
#define _DB_SET_RE_LEN                  40
#define _DB_SET_RE_PAD                  41
#define _DB_SET_RE_SOURCE               42
#define _DB_SET_H_FFACTOR               43
#define _DB_SET_H_NELEM                 44
#define _DB_SET_LORDER                  45
#define _DB_SET_Q_EXTENTSIZE            46
#define _DB_CURSOR                      47
#define _C_CLOSE                        48
#define _C_COUNT                        49
#define _C_DEL                          50
#define _C_GET                          51
#define _C_DUP                          52
#define _C_PUT                          53
#define _SET_LK_CONFLICTS               54
#define _SET_LK_DETECT                  55
#define _SET_LK_MAX_LOCKERS             56
#define _SET_LK_MAX_LOCKS               57
#define _SET_LK_MAX_OBJECTS             58
#define _LOCK_DETECT                    59
#define _LOCK_ID                        60
#define _LOCK_ID_FREE                   61
#define _LOCK_GET                       62
#define _LOCK_PUT                       63
#define _TXN_ABORT                      64

/*
** Constants
*/


#define  MAX_BINVS              24      /* XXX dumb constant! */

#define  VALMAP_INUSE           0x01
#define  VALMAP_DELAYED_CLEANUP 0x02

#define  MAX_RETURN_TERMS       64

/*
** descriptor_t = general state for the port
**
*/

struct descriptor {
    ErlDrvPort          port;
    unsigned short      nextxid;        /* Call txn ID for very async calls */
    DBC *               valmap_cursor[32];
    char                valmap_cursor_flags[32];
    DB_TXN *            valmap_db_txn[32];
    char                valmap_db_txn_flags[32];
    DB *                valmap_db[32];
    char                valmap_db_flags[32];
    DB_ENV *            valmap_dbenv[1];
    char                valmap_dbenv_flags[1];
    pthread_mutex_t     mutex;  /* Protect access to valmap flags */
    ErlDrvBinary        *tofree[MAX_RETURN_TERMS];
    int                 num_tofree;
};

/*
** callstate_t: asychronous call state
**
** TODO: Fill in the struct members of "i" and "o" below.
*/
typedef struct callstate {
    struct callstate    *next;
    int                 cmd;            /* call/command # */
    unsigned int        *key;           /* Not really used */
    void                (*invoke)(void *);
    void                (*free)(void *);
    unsigned short      xid;            /* Only used by as_control()-
                                           initiated funcs */
    struct descriptor   *desc;
    int                 refc_bincount;
    ErlDrvBinary        *refc_bin[MAX_BINVS];
    /*
    ** Input & output args use a struct simply for convenient
    ** naming & grouping.  There isn't any attempt to get smart about
    ** using a union or anything like that to avoid bloating the size
    ** of these structs with the combined args of a zillion different
    ** functions.  XXX For future use: look into the use of unions
    ** and/or different flavors of callstate_t to avoid structure bloat.
    */
    struct {
        int             __valmap_cursor_index;
        int             __valmap_db_txn_index;
        int             __valmap_db_index;
        int             __valmap_dbenv_index;
        unsigned long   __stash[4];
        u_int32_t       flags;
        DB_ENV *        dbenv;
        char *          db_home;
        int             mode;
        char *          dir;
        char *          file;
        char *          fopen_mode;
        char *          errpfx;
        int             onoff;
        CLIENT *        client;
        char *          host;
        long            cl_timeout;
        long            sv_timeout;
        long            shm_key;
        u_int32_t       tas_spins;
        db_timeout_t    timeout;
        int             error;
        DB *            db;
        DB_TXN *        txnid;
        char *          ekey_in;
        DBT             key_in;
        char *          edata_in;
        DBT             data_in;
        char *          database;
        DBTYPE          type;
        char *          newname;
        char *          outfile;
        u_int32_t       gbytes;
        u_int32_t       bytes;
        int             ncache;
        u_int32_t       pagesize;
        u_int32_t       bt_minkey;
        int             re_delim;
        u_int32_t       re_len;
        int             re_pad;
        char *          re_source;
        u_int32_t       h_ffactor;
        u_int32_t       h_nelem;
        int             lorder;
        u_int32_t       extentsize;
        DBC *           dbc;
        u_int8_t *      conflicts;
        int             nmodes;
        u_int32_t       detect;
        u_int32_t       max;
        u_int32_t       atype;
        u_int32_t       id;
        u_int32_t       locker;
        char *          eobj;
        DBT             obj;
        db_lockmode_t   lock_mode;
        char *          elock;
        DB_LOCK         lock;
        DB_TXN *        db_txn;
    } i;
    struct {
        int             __expect;
        int             __expect_errval;
        DB_ENV *        dbenv;
        int             ret_int;
        char *          ret_char_p;
        DB *            db;
        DBC *           cursor;
        int             my_error_value;
        int             major;
        int             minor;
        int             patch;
        int             fd;
        DBTYPE          type;
        u_int32_t       out_u_int32_t;
        int             out_int;
        DB_LOCK         lock;
    } o;
} callstate_t;

/*
** End of autogenerated code
**  script = ../../edtk/c_h_template.gsl
**  filename = berkeley_db.xml
**  gslgen version = 2.000 Beta 1
**  date = 2005/08/16
**  time = 22:06:12
*/

#endif  /* __BERKELEY_DB_DRV_H */
