
#include	<stdio.h>
#include	<sys/time.h>

#include	<pcap.h>
#include	<net/bpf.h>
#include	<sys/ioctl.h>

static int	count = 0;
static pcap_t	*p;

void do_one_packet(u_char *user, const struct pcap_pkthdr *h, const u_char *p);
void fmt_packet(int count, const u_char *pkt);

int
main(int argc, char *argv[])
{
    char		errbuf[PCAP_ERRBUF_SIZE];
    struct timeval	tv;
    u_int		immediate = 1;
    int			last_count = count;
    struct pcap_pkthdr	h;
    u_char		*pkt;

    if (argc != 2) {
	fprintf(stderr, "usage: %s interface-name\n", argv[0]);
	exit(1);
    }
    errbuf[0] = '\0';
    if ((p = pcap_open_live(argv[1], 32768, 1, 2000, errbuf)) == NULL) {
	fprintf(stderr, "open_offline: %s\n", errbuf);
	exit(1);
    }
    if (strlen(errbuf) != 0) {
	fprintf(stderr, "WARNING: %s\n", errbuf);
    }
    if (ioctl(pcap_fileno(p), BIOCIMMEDIATE, &immediate) < 0) {
	perror("ioctl(BIOCIMMEDIATE)");
	exit(1);
    }

    while (1) {
	pkt = pcap_next(p, &h);
	gettimeofday(&tv, NULL);
	fprintf(stderr, "%ld.%06ld pkt = 0x%lx caplen = %d\n", tv.tv_sec, tv.tv_usec, (unsigned long) pkt, (pkt == NULL) ? 0 : h.caplen);
    }
    pcap_close(p);


    exit(0);
}

