
#include	<stdio.h>
#include	<sys/time.h>
#include	<pthread.h>

#include	<pcap.h>
#include	<net/bpf.h>
#include	<sys/ioctl.h>

static int	count = 0;
static pcap_t	*p;

void doit(void *);

/*
** !@#$!@ FreeBSD & Pthreads!!!! TEST4 works just beautifully, timing out
** the pcap_reads() just like I want them to.  But if we're in a pthread
** environment, then the read(2) on the bpf socket doesn't work right,
** apparently because the Pthread library's version of read() notices
** that the read() would block so it uses poll() instead.  When a
** packet finally arrives (which may be waaaaaay after the bpf timeout
** would've expired), then pcap_next() returns.  AAARRRRGGGGHHHHHH!!!!
*/

int
main(int argc, char *argv[])
{
    char		errbuf[PCAP_ERRBUF_SIZE];
    u_int		immediate = 1;
    int			last_count = count;
    pthread_t		junk;

    if (argc != 2) {
	fprintf(stderr, "usage: %s interface-name\n", argv[0]);
	exit(1);
    }
    errbuf[0] = '\0';
    if ((p = pcap_open_live(argv[1], 32768, 1, 2000, errbuf)) == NULL) {
	fprintf(stderr, "open_offline: %s\n", errbuf);
	exit(1);
    }
    if (strlen(errbuf) != 0) {
	fprintf(stderr, "WARNING: %s\n", errbuf);
    }
    if (ioctl(pcap_fileno(p), BIOCIMMEDIATE, &immediate) < 0) {
	perror("ioctl(BIOCIMMEDIATE)");
	exit(1);
    }

    pthread_create(&junk, NULL, doit, NULL);

    sleep(60);

    exit(0);
}

void
doit(void *ptr)
{
    struct pcap_pkthdr	h;
    struct timeval	tv;
    u_char		*pkt;

    while (1) {
	pkt = pcap_next(p, &h);
	gettimeofday(&tv, NULL);
	fprintf(stderr, "%ld.%06ld pkt = 0x%lx caplen = %d\n", tv.tv_sec, tv.tv_usec, (unsigned long) pkt, (pkt == NULL) ? 0 : h.caplen);
    }
    pcap_close(p);

}
