
-module(pli2002_test).

-define(DRV, pli2002_drv).
-define(BUFSIZ, 8192).

-export([file_copy/1, file_copy/2]).

%% command line "-s" usage
file_copy([Src, Dst])
  when atom(Src), atom(Dst) ->
    file_copy(atom_to_list(Src), 
	      atom_to_list(Dst)).

file_copy(Src, Dst) ->
    {ok, Port} = ?DRV:start(),
    {ok, SrcF} = ?DRV:fopen(Port, Src, "r"),
    {ok, DstF} = ?DRV:fopen(Port, Dst, "w"),
    {ok, Buf} = ?DRV:malloc(Port, ?BUFSIZ),
    RFun = fun () -> 
        ?DRV:fread(Port, Buf, 1, ?BUFSIZ, SrcF) end,
    WFun = fun (N) ->
	?DRV:fwrite(Port, Buf, N, DstF) end,
    Val = file_copy2(RFun, WFun),
    %% Shutdown will automatically close
    %% files and free the buffer.
    ?DRV:shutdown(Port),
    Val.

file_copy2(RFun, WFun) ->
    file_copy2(RFun, WFun, RFun()).
file_copy2(RFun, WFun, {ok, N}) ->
    WFun(N),
    file_copy2(RFun, WFun);
file_copy2(RFun, WFun, {error, 0}) ->
    ok;                 % End of file
file_copy2(RFun, WFun, Error) ->
    Error.

%% pli2002_test:file_copy("/etc/motd", "./FOOFOOFOO").
