/*
** Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
** See the file "LICENSE" at the top of the source distribution for
** full license terms.
**
** NOTICE: This file was generated by the tools of the Erlang Driver
**         toolkit.  Do not edit this file by hand unless you know
**         what you're doing!
**
*/

#ifndef __SIMPLE1_DRV_H
#define __SIMPLE1_DRV_H

#ifdef   DRIVER_USING_PTHREADS
#include <pthread.h>
#endif   /* DRIVER_USING_PTHREADS */

/*
** Driver<->emulator communication codes (xref with top of simple1_drv.hrl)
*/

#define S1_DEBUG                        0
#define S1_NULL                         1
#define S1_BIGENDIAN                    2
#define S1_DOUBLEIT                     3
#define S1_ADDTHEM                      4
#define S1_MULTTHEM                     5
#define S1_FOOFOO                       6
#define S1_CTIME_RETURNHACK             7
#define S1_CTIME_TIME_T                 8
#define S1_FOPEN                        9
#define S1_FCLOSE                       10
#define S1_FREAD                        11
#define S1_FREAD_STRING                 12
#define S1_FWRITE                       13
#define S1_OPEN                         14
#define S1_OPEN3                        15
#define S1_CLOSE                        16
#define S1_WRITE                        17
#define S1_READ                         18
#define S1_LSTAT                        19

/*
** Constants
*/

#ifndef CONST1
#define CONST1          0    /* That's a zero */
#endif
#ifndef CONST2
#define CONST2          "Hello, world!"
#endif

#define  MAX_BINVS              24      /* XXX dumb constant! */

#define  VALMAP_INUSE           0x01
#define  VALMAP_DELAYED_CLEANUP 0x02

#define  MAX_RETURN_TERMS       64

/*
** descriptor_t = general state for the port
**
*/

struct descriptor {
    ErlDrvPort          port;
    unsigned short      nextxid;        /* Call txn ID for very async calls */
    int                 valmap_fd[32];
    char                valmap_fd_flags[32];
    pthread_mutex_t     mutex;  /* Protect access to valmap flags */
    ErlDrvBinary        *tofree[MAX_RETURN_TERMS];
    int                 num_tofree;
};

/*
** callstate_t: asychronous call state
**
** TODO: Fill in the struct members of "i" and "o" below.
*/
typedef struct callstate {
    struct callstate    *next;
    int                 cmd;            /* call/command # */
    unsigned int        *key;           /* Not really used */
    void                (*invoke)(void *);
    void                (*free)(void *);
    unsigned short      xid;            /* Only used by as_control()-
                                           initiated funcs */
    struct descriptor   *desc;
    int                 refc_bincount;
    ErlDrvBinary        *refc_bin[MAX_BINVS];
    /*
    ** Input & output args use a struct simply for convenient
    ** naming & grouping.  There isn't any attempt to get smart about
    ** using a union or anything like that to avoid bloating the size
    ** of these structs with the combined args of a zillion different
    ** functions.  XXX For future use: look into the use of unions
    ** and/or different flavors of callstate_t to avoid structure bloat.
    */
    struct {
        int             __valmap_fd_index;
        unsigned long   __stash[3];
        int             x;
        int             y;
        int             mult_y;
        char *          foo1;
        int             foo1_len;
        char *          foo2;
        int             foo2_len;
        char *          foo3;
        int             foo3_len;
        time_t          thetime;
        char *          path;
        char *          fmode;
        FILE *          filep;
        char *          ptr;
        size_t          size;
        size_t          nmemb;
        char *          filename;
        int             flags;
        int             mode;
        int             fd;
        struct stat *   sb;
    } i;
    struct {
        int             __expect;
        int             __expect_errval;
        int             endian;
        int             ret_int;
        char *          str;
        FILE *          filep;
        size_t          ret_size_t;
        ssize_t         ret_ssize_t;
    } o;
} callstate_t;

/*
** End of autogenerated code
**  script = ../../edtk/c_h_template.gsl
**  filename = simple1.xml
**  gslgen version = 2.000 Beta 1
**  date = 2005/08/16
**  time = 22:08:48
*/

#endif  /* __SIMPLE1_DRV_H */
