/*
** File    : berkeley_db_drv.c
** Summary : Erlang driver for the berkeley_db
** 
** NOTICE: This file was generated by the tools of the Erlang Driver
**         toolkit.  Do not edit this file by hand unless you know
**         what you're doing!
** 
** Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
** See the file "LICENSE" at the top of the source distribution for
** full license terms.
*/

/*
** XXX Before I forget yet again to write this down...
**
** ... the valmap ID assignment has a weakness that should be fixed
** sometime in the future.  The weakness is that reusing the array
** indexes could result in Erlang being able to access a later
** incarnation of a valmap table entry by simply remembering a
** previous valmap {valmap_blah, Integer} and resending it to the
** driver, hoping to get (un)lucky.  
**
** The solution would be to choose a valmap index from a larger, very
** unlikely to repeat set, and use a mapping data structure less naive
** than a dumb array.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <assert.h>
#ifdef   DRIVER_USING_PTHREADS
#include <pthread.h>
#else    /* DRIVER_USING_PTHREADS */
#define  pthread_self()         0
#endif   /* DRIVER_USING_PTHREADS */

/* TODO: Add additional system & local header file #includes */

#include <erl_driver.h>
#include <erl_driver_tk.h>

/* <verbatim place="top_cpp_stuff"> */

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <db.h>
#include <rpc/rpc.h>
#include <berkeley_db_drv.h>
#include <my-berkeley_db.h>


/* </verbatim --place="top_cpp_stuff"--> */

/* Last, but not least.... */
#include <berkeley_db_drv.h>

/* <verbatim place="top_other_stuff"> */

/* </verbatim --place="top_other_stuff"--> */

static ErlDrvTermData am_ok;
static ErlDrvTermData am_error;
static ErlDrvTermData am_badarg;
static ErlDrvTermData am_enomem;
static ErlDrvTermData am_unknown;
static ErlDrvTermData am_valmap_cursor;
static ErlDrvTermData am_valmap_db_txn;
static ErlDrvTermData am_valmap_db;
static ErlDrvTermData am_valmap_dbenv;

static int default_async_calls = 1;

/* This variable may be set only by pipe-main! */
int pipe_driver_p = 0;

/*
** TODO: Define any other Erlang terms this driver may return.
*/

/* Function prototypes */

ErlDrvEntry *driver_init(void *);       /* Do not change name! */
static int _init(void);
static ErlDrvData _start(ErlDrvPort port, char *command);
static void _stop(ErlDrvData drv_data);
static void _output(ErlDrvData drv_data, char *buf, int len);
static int _control(ErlDrvData drv_data, unsigned int command, char *buf, int len, char **rbuf, int rlen);
static void _outputv(ErlDrvData drv_data, ErlIOVec *ev);
static void _ready_async(ErlDrvData drv_data, ErlDrvThreadData thread_data);

void *sys_alloc(size_t);
void *sys_realloc(void *, size_t);
void sys_free(void *);

static void invoke__null(void *data);
static void invoke__env_create(void *data);
static void invoke__env_close(void *data);
static void invoke__env_open(void *data);
static void invoke__env_remove(void *data);
static void invoke__env_set_data_dir(void *data);
static void invoke__env_set_errfile(void *data);
static void invoke__env_set_errpfx(void *data);
static void invoke__env_set_flags(void *data);
static void invoke__env_set_rpc_server(void *data);
static void invoke__env_set_shm_key(void *data);
static void invoke__env_set_tas_spins(void *data);
static void invoke__env_set_tmp_dir(void *data);
static void invoke__env_set_timeout(void *data);
static void invoke__env_set_verbose(void *data);
static void invoke__db_strerror(void *data);
static void invoke__db_version(void *data);
static void invoke__db_create(void *data);
static void invoke__db_close(void *data);
static void invoke__db_del(void *data);
static void invoke__db_fd(void *data);
static void invoke__db_get(void *data);
static void invoke__db_get_byteswapped(void *data);
static void invoke__db_get_type(void *data);
static void invoke__db_open(void *data);
static void invoke__db_put(void *data);
static void invoke__db_remove(void *data);
static void invoke__db_rename(void *data);
static void invoke__db_sync(void *data);
static void invoke__db_truncate(void *data);
static void invoke__db_upgrade(void *data);
static void invoke__db_verify(void *data);
static void invoke__db_set_cachesize(void *data);
static void invoke__db_set_errfile(void *data);
static void invoke__db_set_errpfx(void *data);
static void invoke__db_set_flags(void *data);
static void invoke__db_set_pagesize(void *data);
static void invoke__db_set_bt_minkey(void *data);
static void invoke__db_set_re_delim(void *data);
static void invoke__db_set_re_len(void *data);
static void invoke__db_set_re_pad(void *data);
static void invoke__db_set_re_source(void *data);
static void invoke__db_set_h_ffactor(void *data);
static void invoke__db_set_h_nelem(void *data);
static void invoke__db_set_lorder(void *data);
static void invoke__db_set_q_extentsize(void *data);
static void invoke__db_cursor(void *data);
static void invoke__c_close(void *data);
static void invoke__c_count(void *data);
static void invoke__c_del(void *data);
static void invoke__c_get(void *data);
static void invoke__c_dup(void *data);
static void invoke__c_put(void *data);
static void invoke__set_lk_conflicts(void *data);
static void invoke__set_lk_detect(void *data);
static void invoke__set_lk_max_lockers(void *data);
static void invoke__set_lk_max_locks(void *data);
static void invoke__set_lk_max_objects(void *data);
static void invoke__lock_detect(void *data);
static void invoke__lock_id(void *data);
static void invoke__lock_id_free(void *data);
static void invoke__lock_get(void *data);
static void invoke__lock_put(void *data);
static void invoke__txn_abort(void *data);

static int reply_xtra_db_version(descriptor_t *, callstate_t *);
static int reply_xtra_db_fd(descriptor_t *, callstate_t *);
static int reply_xtra_DBTYPE(descriptor_t *, callstate_t *);
static int reply_xtra_out_u_int32_t(descriptor_t *, callstate_t *);
static int reply_xtra_out_int(descriptor_t *, callstate_t *);
static int reply_xtra_key_data(descriptor_t *, callstate_t *);
static int reply_xtra_lock(descriptor_t *, callstate_t *);

static int find_unused_cursor_index(descriptor_t *, unsigned long *);
static void cleanup_valmap_cursor_index(descriptor_t *, int, int);
static void cleanup_valmap_cursor_all(descriptor_t *, int);
static int find_unused_db_txn_index(descriptor_t *, unsigned long *);
static void cleanup_valmap_db_txn_index(descriptor_t *, int, int);
static void cleanup_valmap_db_txn_all(descriptor_t *, int);
static int find_unused_db_index(descriptor_t *, unsigned long *);
static void cleanup_valmap_db_index(descriptor_t *, int, int);
static void cleanup_valmap_db_all(descriptor_t *, int);
static int find_unused_dbenv_index(descriptor_t *, unsigned long *);
static void cleanup_valmap_dbenv_index(descriptor_t *, int, int);
static void cleanup_valmap_dbenv_all(descriptor_t *, int);

static int reply_ok(descriptor_t *desc);
static int reply_ok_num(descriptor_t *desc, unsigned long num);
static int reply_ok_binary(descriptor_t *desc, char *p, int, int);
static int reply_ok_valmap(descriptor_t *, ErlDrvTermData, unsigned long);
static int reply_error(descriptor_t *desc, int errnum);
static int reply_error_atom(descriptor_t *, ErlDrvTermData);
#if     0
static int reply_tag_ok(descriptor_t *desc, unsigned short tag);
static int reply_tag_error(descriptor_t *desc, unsigned short tag, int errnum);
#endif  /* 0 */

static ErlDrvEntry _driver_entry = {
    _init,                      /* init */
    _start,                     /* start */
    _stop,                      /* stop */
    _output,                    /* output */
    NULL,                       /* ready_input */
    NULL,                       /* ready_output */
    "berkeley_db_drv",          /* driver_name */
    NULL,                       /* finish */
    NULL,                       /* handle */
    _control,                   /* control */
    NULL,                       /* timeout */
    _outputv,                   /* outputv */
    _ready_async,               /* ready_async */
    NULL,                       /* flush */
    NULL                        /* call */
};

/*
** All dynamically-loadable driver libraries must contain a driver_init().
*/

ErlDrvEntry *
driver_init(void *handle)
{
    edtk_debug_flag = 0;
    _driver_entry.handle = handle;
    return &_driver_entry;
}

static int
_init(void)
{
    am_ok = driver_mk_atom("ok");
    am_error = driver_mk_atom("error");
    am_badarg = driver_mk_atom("badarg");
    am_enomem = driver_mk_atom("enomem");
    am_unknown = driver_mk_atom("unknown");
    am_valmap_cursor = driver_mk_atom("valmap_cursor");
    am_valmap_db_txn = driver_mk_atom("valmap_db_txn");
    am_valmap_db = driver_mk_atom("valmap_db");
    am_valmap_dbenv = driver_mk_atom("valmap_dbenv");

    /* TODO: Take care of other first-time initialization tasks */

    return 0;
}

static ErlDrvData
_start(ErlDrvPort port, char *args)
{
    descriptor_t        *desc;
    int                 i = 0;

    i = i;
    edtk_debug("%s: starting, port = %ld, args = 0x%lx, %s", __FUNCTION__,
               port, (unsigned long) args, args);

    if ((desc = (descriptor_t *) sys_alloc(sizeof(descriptor_t))) == NULL) {
        return ERL_DRV_ERROR_GENERAL;
    }
    memset(desc, 0, sizeof(descriptor_t));
    desc->port = port;
    desc->nextxid = 1;
    for (i = 0; i < 32; i++) {
        desc->valmap_cursor[i] = NULL;
        desc->valmap_cursor_flags[i] = 0;
    }
    for (i = 0; i < 32; i++) {
        desc->valmap_db_txn[i] = NULL;
        desc->valmap_db_txn_flags[i] = 0;
    }
    for (i = 0; i < 32; i++) {
        desc->valmap_db[i] = NULL;
        desc->valmap_db_flags[i] = 0;
    }
    for (i = 0; i < 1; i++) {
        desc->valmap_dbenv[i] = NULL;
        desc->valmap_dbenv_flags[i] = 0;
    }
    pthread_mutex_init(&desc->mutex, NULL);
    /* TODO: Finish initializing descriptor members */

    /* TODO: Take care of other port initialization tasks */

    return (ErlDrvData) desc;
}

static void
_stop(ErlDrvData drv_data)
{
    descriptor_t        *desc = (descriptor_t *) drv_data;
    int                 i = 0;
    ErlDrvPort          port;
    int                 still_in_use = 0;

    i = i;
    if (desc == NULL) {
        edtk_debug("%s: drv_data == NULL", __FUNCTION__);
        return;
    }
    edtk_debug("%s: port = %ld", __FUNCTION__, desc->port);

    for (i = 0; i < 32; i++) {
        /* Safe to look at flags here without getting mutex, right? */
        if (desc->valmap_cursor_flags[i] & VALMAP_INUSE) {
            edtk_debug("%s: desc->valmap_cursor_flags[%d] still in use!", __FUNCTION__, i);
            still_in_use++;
        } else
        if (desc->valmap_cursor[i] != NULL) {
            cleanup_valmap_cursor_index(desc, i, 1);
        }
    }
    for (i = 0; i < 32; i++) {
        /* Safe to look at flags here without getting mutex, right? */
        if (desc->valmap_db_txn_flags[i] & VALMAP_INUSE) {
            edtk_debug("%s: desc->valmap_db_txn_flags[%d] still in use!", __FUNCTION__, i);
            still_in_use++;
        } else
        if (desc->valmap_db_txn[i] != NULL) {
            cleanup_valmap_db_txn_index(desc, i, 1);
        }
    }
    for (i = 0; i < 32; i++) {
        /* Safe to look at flags here without getting mutex, right? */
        if (desc->valmap_db_flags[i] & VALMAP_INUSE) {
            edtk_debug("%s: desc->valmap_db_flags[%d] still in use!", __FUNCTION__, i);
            still_in_use++;
        } else
        if (desc->valmap_db[i] != NULL) {
            cleanup_valmap_db_index(desc, i, 1);
        }
    }
    for (i = 0; i < 1; i++) {
        /* Safe to look at flags here without getting mutex, right? */
        if (desc->valmap_dbenv_flags[i] & VALMAP_INUSE) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] still in use!", __FUNCTION__, i);
            still_in_use++;
        } else
        if (desc->valmap_dbenv[i] != NULL) {
            cleanup_valmap_dbenv_index(desc, i, 1);
        }
    }

    if (! still_in_use) {
        port = desc->port;
        sys_free(desc);    
        edtk_debug("%s: port = %ld finished", __FUNCTION__, port);
    } else {
        /*
        ** XXX Oi, this is a sticky problem.  This port is being shut
        ** down, but we've still got some valmaps in use.  We have no
        ** way to tell the VM that we cannot be shut down safely right
        ** now, so what in the heck do we do?  It seems to me that we
        ** have two choices:
        **   1. Block the entire VM until all valmaps are idle, then
        **      clean them up and then return.
        **   2. Create a new thread that will take care of monitoring
        **      the valmaps & doing their final cleanup.  This stop
        **      function, executing in the main thread, can return
        **      to the VM right away.
        ** For the sake of simplicity, I'm going to implement #1
        ** for now.  This will get more complicated once EDTK supports
        ** private worker threads, so we won't bother getting fancy
        ** for now.
        */
        edtk_debug("%s: port = %ld has %d valmaps still in use!", __FUNCTION__, desc->port, still_in_use);
        sleep(1);
        _stop(drv_data);                /* Hope we don't run out of stack */
    }
}

static void
_output(ErlDrvData drv_data, char *buf, int len)
{
    /*
    ** Nobody should be calling this function because we've
    ** defined the "outputv" driver method, which BEAM will always
    ** used if it's available.  I just put a debug statement in
    ** here so that I might actually notice if the impossible ever
    ** happens....
    */
    edtk_debug("%s: XXX someone tried to call us, silly", __FUNCTION__);
}


static int
_control(ErlDrvData drv_data, unsigned int command,
                  char *buf, int len, char **rbuf, int rlen)
{
    char        *ret = *rbuf;
    int         retlen;

    /*
    ** Nobody should be calling this function either.
    */
    ret[0] = 1;
    retlen = 1;
    edtk_debug("%s: XXX someone tried to call us, silly", __FUNCTION__);
    return retlen;
}

static void
_outputv(ErlDrvData drv_data, ErlIOVec *ev)
{
    descriptor_t        *desc = (descriptor_t *) drv_data;
    unsigned char       cmd;
    int                 p = 0, q = 1;
    callstate_t         *c = NULL;
    int                 do_async_call = default_async_calls;
    unsigned long       binlen;
    int                 index;
    void                *tmp = NULL;

    binlen = binlen;
    index = index;
    tmp = tmp;
    if (desc == NULL || ev == NULL || ev->size < 1) {
        edtk_debug("%s: bad arg(s)", __FUNCTION__);
        return;
    }
    if (! EV_GET_CHAR(ev, &cmd, &p, &q)) {
        edtk_debug("%s: empty command", __FUNCTION__);
        reply_error(desc, EINVAL);
    }
    if ((c = sys_alloc(sizeof(callstate_t))) == NULL) {
        reply_error(desc, ENOMEM);
        return;
    }
    c->cmd = cmd;
    c->key = NULL;
    c->free = sys_free;
    c->xid = 0;         /* XXX unused right now */
    c->o.__expect = 1;  /* Default is that expectation is always met */
    c->desc = desc;
    c->refc_bincount = 0;

    edtk_debug("%s: my threadid = %lx, cmd = %d", __FUNCTION__, pthread_self(), cmd);
    switch (cmd) {
    case _DEBUG:
        EV_GET_UINT32(ev, &edtk_debug_flag, &p, &q);
        reply_ok_num(desc, edtk_debug_flag);    /* Immediate reply */
        sys_free(c);
        c = NULL;
        break;
    case _NULL:
        c->invoke = invoke__null;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        break;
    case _ENV_CREATE:
        c->invoke = invoke__env_create;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        break;
    case _ENV_CLOSE:
        c->invoke = invoke__env_close;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_OPEN:
        c->invoke = invoke__env_open;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.db_home = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        EV_GET_UINT32(ev, &c->i.mode, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        if (strlen(c->i.db_home) == 0) {
            c->i.db_home = NULL;
        }
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_REMOVE:
        c->invoke = invoke__env_remove;
        do_async_call =  0;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.db_home = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        if (strlen(c->i.db_home) == 0) {
            c->i.db_home = NULL;
        }
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_DATA_DIR:
        c->invoke = invoke__env_set_data_dir;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.dir = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_ERRFILE:
        c->invoke = invoke__env_set_errfile;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.file = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.fopen_mode = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_ERRPFX:
        c->invoke = invoke__env_set_errpfx;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.errpfx = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_FLAGS:
        c->invoke = invoke__env_set_flags;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        EV_GET_UINT32(ev, &c->i.onoff, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_RPC_SERVER:
        c->invoke = invoke__env_set_rpc_server;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.host = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.cl_timeout, &p, &q);
        EV_GET_UINT32(ev, &c->i.sv_timeout, &p, &q);
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        c->i.client = NULL;
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_SHM_KEY:
        c->invoke = invoke__env_set_shm_key;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.shm_key, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_TAS_SPINS:
        c->invoke = invoke__env_set_tas_spins;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.tas_spins, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_TMP_DIR:
        c->invoke = invoke__env_set_tmp_dir;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.dir = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_TIMEOUT:
        c->invoke = invoke__env_set_timeout;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.timeout, &p, &q);
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _ENV_SET_VERBOSE:
        c->invoke = invoke__env_set_verbose;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        EV_GET_UINT32(ev, &c->i.onoff, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_STRERROR:
        c->invoke = invoke__db_strerror;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &c->i.error, &p, &q);
        break;
    case _DB_VERSION:
        c->invoke = invoke__db_version;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        break;
    case _DB_CREATE:
        c->invoke = invoke__db_create;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_CLOSE:
        c->invoke = invoke__db_close;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_DEL:
        c->invoke = invoke__db_del;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 1 == 1) {
            edtk_debug("%s: valmap db_txn index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.txnid = NULL;
            c->i.__valmap_db_txn_index = -1;
        } else if (desc->valmap_db_txn[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db_txn index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db_txn[index]);
            c->i.txnid = desc->valmap_db_txn[index];
            c->i.__valmap_db_txn_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[0] = binlen;
        c->i.ekey_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        memset(&c->i.key_in, 0, sizeof(c->i.key_in));
        c->i.key_in.data = c->i.ekey_in;
        c->i.key_in.size = c->i.__stash[0];
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        if (c->i.__valmap_db_txn_index >= 0) {
            edtk_debug("%s: desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
            assert(desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] == 0);
            desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_FD:
        c->invoke = invoke__db_fd;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_GET:
        c->invoke = invoke__db_get;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 1 == 1) {
            edtk_debug("%s: valmap db_txn index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.txnid = NULL;
            c->i.__valmap_db_txn_index = -1;
        } else if (desc->valmap_db_txn[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db_txn index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db_txn[index]);
            c->i.txnid = desc->valmap_db_txn[index];
            c->i.__valmap_db_txn_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[0] = binlen;
        c->i.ekey_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[1] = binlen;
        c->i.edata_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        memset(&c->i.key_in, 0, sizeof(c->i.key_in));
        c->i.key_in.data = c->i.ekey_in;
        c->i.key_in.size = c->i.__stash[0];
        c->i.key_in.flags = DB_DBT_MALLOC;
        memset(&c->i.data_in, 0, sizeof(c->i.data_in));
        c->i.data_in.data = c->i.edata_in;
        c->i.data_in.size = c->i.__stash[1];
        c->i.data_in.flags = DB_DBT_MALLOC;
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        if (c->i.__valmap_db_txn_index >= 0) {
            edtk_debug("%s: desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
            assert(desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] == 0);
            desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_GET_BYTESWAPPED:
        c->invoke = invoke__db_get_byteswapped;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_GET_TYPE:
        c->invoke = invoke__db_get_type;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_OPEN:
        c->invoke = invoke__db_open;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.file = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.database = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.type, &p, &q);
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        EV_GET_UINT32(ev, &c->i.mode, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        /* QQQ file & database may be NULL for in-memory table */
        if (strlen(c->i.file) == 0) {
            c->i.file = NULL;
        }
        if (strlen(c->i.database) == 0) {
            c->i.database = NULL;
        }
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_PUT:
        c->invoke = invoke__db_put;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 1 == 1) {
            edtk_debug("%s: valmap db_txn index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.txnid = NULL;
            c->i.__valmap_db_txn_index = -1;
        } else if (desc->valmap_db_txn[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db_txn index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db_txn[index]);
            c->i.txnid = desc->valmap_db_txn[index];
            c->i.__valmap_db_txn_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[0] = binlen;
        c->i.ekey_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[1] = binlen;
        c->i.edata_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        memset(&c->i.key_in, 0, sizeof(c->i.key_in));
        c->i.key_in.data = c->i.ekey_in;
        c->i.key_in.size = c->i.__stash[0];
        memset(&c->i.data_in, 0, sizeof(c->i.data_in));
        c->i.data_in.data = c->i.edata_in;
        c->i.data_in.size = c->i.__stash[1];
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        if (c->i.__valmap_db_txn_index >= 0) {
            edtk_debug("%s: desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
            assert(desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] == 0);
            desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_REMOVE:
        c->invoke = invoke__db_remove;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.file = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.database = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        /* QQQ file & database may be NULL for in-memory table */
        if (strlen(c->i.file) == 0) {
            c->i.file = NULL;
        }
        if (strlen(c->i.database) == 0) {
            c->i.database = NULL;
        }
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_RENAME:
        c->invoke = invoke__db_rename;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.file = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.database = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.newname = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        /* QQQ file & database may be NULL for in-memory table */
        if (strlen(c->i.file) == 0) {
            c->i.file = NULL;
        }
        if (strlen(c->i.database) == 0) {
            c->i.database = NULL;
        }
        /* Doesn't make sense to check length of newname */
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SYNC:
        c->invoke = invoke__db_sync;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_TRUNCATE:
        c->invoke = invoke__db_truncate;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 1 == 1) {
            edtk_debug("%s: valmap db_txn index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.txnid = NULL;
            c->i.__valmap_db_txn_index = -1;
        } else if (desc->valmap_db_txn[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db_txn index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db_txn[index]);
            c->i.txnid = desc->valmap_db_txn[index];
            c->i.__valmap_db_txn_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        if (c->i.__valmap_db_txn_index >= 0) {
            edtk_debug("%s: desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
            assert(desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] == 0);
            desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_UPGRADE:
        c->invoke = invoke__db_upgrade;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.file = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_VERIFY:
        c->invoke = invoke__db_verify;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.file = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.database = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.outfile = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        if (strlen(c->i.database) == 0) {
            c->i.database = NULL;
        }
        if (strlen(c->i.outfile) == 0) {
            c->i.outfile = NULL;
        }
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_CACHESIZE:
        c->invoke = invoke__db_set_cachesize;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.gbytes, &p, &q);
        EV_GET_UINT32(ev, &c->i.bytes, &p, &q);
        EV_GET_UINT32(ev, &c->i.ncache, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_ERRFILE:
        c->invoke = invoke__db_set_errfile;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.file = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.fopen_mode = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_ERRPFX:
        c->invoke = invoke__db_set_errpfx;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.errpfx = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_FLAGS:
        c->invoke = invoke__db_set_flags;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_PAGESIZE:
        c->invoke = invoke__db_set_pagesize;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.pagesize, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_BT_MINKEY:
        c->invoke = invoke__db_set_bt_minkey;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.bt_minkey, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_RE_DELIM:
        c->invoke = invoke__db_set_re_delim;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.re_delim, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_RE_LEN:
        c->invoke = invoke__db_set_re_len;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.re_len, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_RE_PAD:
        c->invoke = invoke__db_set_re_pad;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.re_pad, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_RE_SOURCE:
        c->invoke = invoke__db_set_re_source;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.re_source = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_H_FFACTOR:
        c->invoke = invoke__db_set_h_ffactor;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.h_ffactor, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_H_NELEM:
        c->invoke = invoke__db_set_h_nelem;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.h_nelem, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_LORDER:
        c->invoke = invoke__db_set_lorder;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.lorder, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_SET_Q_EXTENTSIZE:
        c->invoke = invoke__db_set_q_extentsize;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &c->i.extentsize, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _DB_CURSOR:
        c->invoke = invoke__db_cursor;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db = NULL;
            c->i.__valmap_db_index = -1;
        } else if (desc->valmap_db[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db[index]);
            c->i.db = desc->valmap_db[index];
            c->i.__valmap_db_index = index;
        }
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 1 == 1) {
            edtk_debug("%s: valmap db_txn index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.txnid = NULL;
            c->i.__valmap_db_txn_index = -1;
        } else if (desc->valmap_db_txn[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db_txn index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db_txn[index]);
            c->i.txnid = desc->valmap_db_txn[index];
            c->i.__valmap_db_txn_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_index >= 0) {
            edtk_debug("%s: desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
            assert(desc->valmap_db_flags[c->i.__valmap_db_index] == 0);
            desc->valmap_db_flags[c->i.__valmap_db_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, desc->valmap_db_flags[c->i.__valmap_db_index]);
        }
        if (c->i.__valmap_db_txn_index >= 0) {
            edtk_debug("%s: desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
            assert(desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] == 0);
            desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _C_CLOSE:
        c->invoke = invoke__c_close;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap cursor index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbc = NULL;
            c->i.__valmap_cursor_index = -1;
        } else if (desc->valmap_cursor[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap cursor index %d = 0x%lx", __FUNCTION__, index, desc->valmap_cursor[index]);
            c->i.dbc = desc->valmap_cursor[index];
            c->i.__valmap_cursor_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_cursor_index >= 0) {
            edtk_debug("%s: desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
            assert(desc->valmap_cursor_flags[c->i.__valmap_cursor_index] == 0);
            desc->valmap_cursor_flags[c->i.__valmap_cursor_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _C_COUNT:
        c->invoke = invoke__c_count;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap cursor index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbc = NULL;
            c->i.__valmap_cursor_index = -1;
        } else if (desc->valmap_cursor[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap cursor index %d = 0x%lx", __FUNCTION__, index, desc->valmap_cursor[index]);
            c->i.dbc = desc->valmap_cursor[index];
            c->i.__valmap_cursor_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_cursor_index >= 0) {
            edtk_debug("%s: desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
            assert(desc->valmap_cursor_flags[c->i.__valmap_cursor_index] == 0);
            desc->valmap_cursor_flags[c->i.__valmap_cursor_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _C_DEL:
        c->invoke = invoke__c_del;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap cursor index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbc = NULL;
            c->i.__valmap_cursor_index = -1;
        } else if (desc->valmap_cursor[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap cursor index %d = 0x%lx", __FUNCTION__, index, desc->valmap_cursor[index]);
            c->i.dbc = desc->valmap_cursor[index];
            c->i.__valmap_cursor_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_cursor_index >= 0) {
            edtk_debug("%s: desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
            assert(desc->valmap_cursor_flags[c->i.__valmap_cursor_index] == 0);
            desc->valmap_cursor_flags[c->i.__valmap_cursor_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _C_GET:
        c->invoke = invoke__c_get;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap cursor index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbc = NULL;
            c->i.__valmap_cursor_index = -1;
        } else if (desc->valmap_cursor[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap cursor index %d = 0x%lx", __FUNCTION__, index, desc->valmap_cursor[index]);
            c->i.dbc = desc->valmap_cursor[index];
            c->i.__valmap_cursor_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[0] = binlen;
        c->i.ekey_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[1] = binlen;
        c->i.edata_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        memset(&c->i.key_in, 0, sizeof(c->i.key_in));
        c->i.key_in.data = c->i.ekey_in;
        c->i.key_in.size = c->i.__stash[0];
        c->i.key_in.flags = DB_DBT_MALLOC;
        memset(&c->i.data_in, 0, sizeof(c->i.data_in));
        c->i.data_in.data = c->i.edata_in;
        c->i.data_in.size = c->i.__stash[1];
        c->i.data_in.flags = DB_DBT_MALLOC;
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_cursor_index >= 0) {
            edtk_debug("%s: desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
            assert(desc->valmap_cursor_flags[c->i.__valmap_cursor_index] == 0);
            desc->valmap_cursor_flags[c->i.__valmap_cursor_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _C_DUP:
        c->invoke = invoke__c_dup;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap cursor index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbc = NULL;
            c->i.__valmap_cursor_index = -1;
        } else if (desc->valmap_cursor[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap cursor index %d = 0x%lx", __FUNCTION__, index, desc->valmap_cursor[index]);
            c->i.dbc = desc->valmap_cursor[index];
            c->i.__valmap_cursor_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_cursor_index >= 0) {
            edtk_debug("%s: desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
            assert(desc->valmap_cursor_flags[c->i.__valmap_cursor_index] == 0);
            desc->valmap_cursor_flags[c->i.__valmap_cursor_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _C_PUT:
        c->invoke = invoke__c_put;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap cursor index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbc = NULL;
            c->i.__valmap_cursor_index = -1;
        } else if (desc->valmap_cursor[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap cursor index %d = 0x%lx", __FUNCTION__, index, desc->valmap_cursor[index]);
            c->i.dbc = desc->valmap_cursor[index];
            c->i.__valmap_cursor_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[0] = binlen;
        c->i.ekey_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[1] = binlen;
        c->i.edata_in = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        memset(&c->i.key_in, 0, sizeof(c->i.key_in));
        c->i.key_in.data = c->i.ekey_in;
        c->i.key_in.size = c->i.__stash[0];
        memset(&c->i.data_in, 0, sizeof(c->i.data_in));
        c->i.data_in.data = c->i.edata_in;
        c->i.data_in.size = c->i.__stash[1];
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_cursor_index >= 0) {
            edtk_debug("%s: desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
            assert(desc->valmap_cursor_flags[c->i.__valmap_cursor_index] == 0);
            desc->valmap_cursor_flags[c->i.__valmap_cursor_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _SET_LK_CONFLICTS:
        c->invoke = invoke__set_lk_conflicts;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.conflicts = (u_int8_t *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.nmodes, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _SET_LK_DETECT:
        c->invoke = invoke__set_lk_detect;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.detect, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _SET_LK_MAX_LOCKERS:
        c->invoke = invoke__set_lk_max_lockers;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.max, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _SET_LK_MAX_LOCKS:
        c->invoke = invoke__set_lk_max_locks;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.max, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _SET_LK_MAX_OBJECTS:
        c->invoke = invoke__set_lk_max_objects;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.max, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _LOCK_DETECT:
        c->invoke = invoke__lock_detect;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        EV_GET_UINT32(ev, &c->i.atype, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _LOCK_ID:
        c->invoke = invoke__lock_id;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _LOCK_ID_FREE:
        c->invoke = invoke__lock_id_free;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.id, &p, &q);
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _LOCK_GET:
        c->invoke = invoke__lock_get;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &c->i.locker, &p, &q);
        EV_GET_UINT32(ev, &c->i.flags, &p, &q);
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[0] = binlen;
        c->i.eobj = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        EV_GET_UINT32(ev, &c->i.lock_mode, &p, &q);
        /* <hack place="post-deserialize" type="verbatim"> */

        memset(&c->i.obj, 0, sizeof(c->i.obj));
        c->i.obj.data = c->i.eobj;
        c->i.obj.size = c->i.__stash[0];
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _LOCK_PUT:
        c->invoke = invoke__lock_put;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap dbenv index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.dbenv = NULL;
            c->i.__valmap_dbenv_index = -1;
        } else if (desc->valmap_dbenv[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap dbenv index %d = 0x%lx", __FUNCTION__, index, desc->valmap_dbenv[index]);
            c->i.dbenv = desc->valmap_dbenv[index];
            c->i.__valmap_dbenv_index = index;
        }
        EV_GET_UINT32(ev, &binlen, &p, &q);
        c->i.__stash[0] = binlen;
        c->i.elock = (char *) EV_GETPOS(ev, p, q);
        if (do_async_call) {
            if (c->refc_bincount == MAX_BINVS) {
                goto error;
            }
            ev->binv[q]->refc++;
            c->refc_bin[c->refc_bincount++] = ev->binv[q];
        }
        if (edtk_ev_forward_N(ev, binlen, &p, &q, 1) < 0) {
            goto error;
        }
        /* <hack place="post-deserialize" type="verbatim"> */

        memcpy(&c->i.lock, c->i.elock, c->i.__stash[0]);
 
        /* </hack --place="post-deserialize" type="verbatim"--> */
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_dbenv_index >= 0) {
            edtk_debug("%s: desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
            assert(desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] == 0);
            desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
    case _TXN_ABORT:
        c->invoke = invoke__txn_abort;
        /* Do not ever do async call if we're in pipe driver mode */
        do_async_call =  pipe_driver_p ? 0 : do_async_call;
        EV_GET_UINT32(ev, &index, &p, &q);
        if (index == -1 && 0 == 1) {
            edtk_debug("%s: valmap db_txn index %d = default value 0x%lx", __FUNCTION__, index, NULL);
            c->i.db_txn = NULL;
            c->i.__valmap_db_txn_index = -1;
        } else if (desc->valmap_db_txn[index] == NULL) {
            goto error;
        } else {
            edtk_debug("%s: valmap db_txn index %d = 0x%lx", __FUNCTION__, index, desc->valmap_db_txn[index]);
            c->i.db_txn = desc->valmap_db_txn[index];
            c->i.__valmap_db_txn_index = index;
        }
        /* Begin valmap flag adjustment */
        pthread_mutex_lock(&desc->mutex);
        if (c->i.__valmap_db_txn_index >= 0) {
            edtk_debug("%s: desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
            assert(desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] == 0);
            desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] |= VALMAP_INUSE;
            edtk_debug("%s: INUSE set, desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        }
        pthread_mutex_unlock(&desc->mutex);
        /* End valmap flag adjustment */
        break;
     default:
        edtk_debug("%s: invalid command %d", __FUNCTION__, cmd);
        goto error;
        break;  
    }
    if (c != NULL) {
        if (do_async_call) {
            driver_async(desc->port, c->key, c->invoke, c, c->free);
        } else {
            /*
            ** Execute the bottom half right away, then send the result.
            */
            (*(c->invoke))((void *) c);
            _ready_async((ErlDrvData) desc, (ErlDrvThreadData) c);
            /* 
            ** c is already freed for us by _ready_async()
            */
        }
    }
    return;

  error:
    if (c != NULL) {
        sys_free(c);
    }
    reply_error_atom(desc, am_badarg);
}

static void
_ready_async(ErlDrvData drv_data, ErlDrvThreadData thread_data)
{
    descriptor_t        *desc = (descriptor_t *) drv_data;
    callstate_t *c = (callstate_t *) thread_data;
    int                 bytes, offset, i;
    char                *p = NULL;
    unsigned long       index = 0;

    p = p;
    bytes = bytes;
    offset = offset;
    i = i;
    index = index;
    edtk_debug("%s: cmd = %d", __FUNCTION__, c->cmd);
    if (c == NULL) {
        edtk_debug("%s: c == NULL", __FUNCTION__);
        return;
    }
    switch (c->cmd) {
    case _NULL:
        reply_ok(desc);
        break;
    case _ENV_CREATE:
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        /* <hack place="ready_async-pre-reply" type="verbatim"> */

        {
            int err;

            /* Remember: newly-created dbenv is in c->o.dbenv!! */
            c->o.dbenv->set_errcall(c->o.dbenv, my_debug_errcall);
            if ((err = c->o.dbenv->set_alloc(c->o.dbenv,
                                             edtk_driver_alloc_wrapper,
                                             edtk_driver_realloc_wrapper,
                                             edtk_driver_free_wrapper
                                             )) != 0) {
                reply_error(desc, err);
            }
        }
 
        /* </hack --place="ready_async-pre-reply" type="verbatim"--> */
        if (find_unused_dbenv_index(desc, &index) < 0) {
            reply_error(desc, ENOMEM);
        } else {
            desc->valmap_dbenv[index] = c->o.dbenv;
            reply_ok_valmap(desc, am_valmap_dbenv, index);
        }
        break;
    case _ENV_CLOSE:
        /* <hack place="ready_async-case-top" type="verbatim"> */

        /* 
        ** Quoting DB docs:
        ** "After DB_ENV->close has been called, regardless of its
        ** return, the Berkeley DB environment handle may not be
        ** accessed again."
        **
        ** Not only can't we use the environment handle again, but we
        ** can never use any other handles associated with that
        ** environment.
        */
        /*
        ** QQQ Berkeley DB poses a larger question: is there a
        ** practical way to protect the VM from a badly-written
        ** driver?  Actually, yes: move it out of the VM's process!
        ** Hrm, I'll bet that if I have a cursor open in a table,
        ** then DB->close that table, I'll cause the same sort of
        ** "accessing bogus handle" crash that happens if the hack
        ** below isn't used.  HRRM!  It sure would be nice to be
        ** able to easily create a tree of valmap dependencies and
        ** clear out all the correct valmap entries if something goes
        ** wrong.  HRM....
        **
        ** Hrm.  It's easy enough to add a "depends_on_valmap" attrib
        ** to a valmap definition.  That could create the dependency
        ** graph that could then be used to trigger a cascade of
        ** valmap cleanups.
        **
        ** The current dependency graph is:
        **
        ** cursor --> DB --> ENV
        **   |         ^     ^
        **   |        ?|?    |
        **   +------> TXN ---/
        **
        ** Hrm, except that the graph could get pretty complex,
        ** contain cycles, etc.  Bleh.  Perhaps my cursor2tab
        ** mapping in the first draft is good enough 'cause Berkeley
        ** DB is a special case?  (QQQ Aside from being incomplete:
        ** we also need a db2env dependency mapping.  Also dunno
        ** if the TXN->DB dependency needs mapping: if you create
        ** a TXN that operates on a DB, then you remove the DB,
        ** then access the TXN handle, what happens?  If nothing,
        ** cool!  If it blows up, then ... keep track of all the
        ** DBs which are currently taking part in a TXN???
        **
        */
        /* QQQ cleanup_valmap_cursor_all(desc, 0); */
        cleanup_valmap_db_txn_all(desc, 0);
        cleanup_valmap_db_all(desc, 0);
        cleanup_valmap_dbenv_all(desc, 0);
 
        /* </hack --place="ready_async-case-top" type="verbatim"--> */
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        cleanup_valmap_dbenv_index(desc, c->i.__valmap_dbenv_index, 0);
        reply_ok_num(desc, c->o.ret_int);
        break;
    case _ENV_OPEN:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_REMOVE:
        /* <hack place="ready_async-case-top" type="verbatim"> */

        /* 
        ** Quoting DB docs:
        ** "After DB_ENV->close has been called, regardless of its
        ** return, the Berkeley DB environment handle may not be
        ** accessed again."
        **
        ** Not only can't we use the environment handle again, but we
        ** can never use any other handles associated with that
        ** environment.
        */
        /* QQQ cleanup_valmap_cursor_all(desc, 0); */
        cleanup_valmap_db_txn_all(desc, 0);
        cleanup_valmap_db_all(desc, 0);
        cleanup_valmap_dbenv_all(desc, 0);
 
        /* </hack --place="ready_async-case-top" type="verbatim"--> */
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_DATA_DIR:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_ERRFILE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_ERRPFX:
        reply_ok(desc);
        break;
    case _ENV_SET_FLAGS:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_RPC_SERVER:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_SHM_KEY:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_TAS_SPINS:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_TMP_DIR:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_TIMEOUT:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _ENV_SET_VERBOSE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_STRERROR:
        bytes = strlen(c->o.ret_char_p);
        offset = 0;
        if ((p = edtk_driver_alloc_wrapper(bytes)) == NULL) {
            reply_error(desc, ENOMEM);
        } else {
            memcpy(p, c->o.ret_char_p, bytes);
            reply_ok_binary(desc, p, 0, bytes);
        }
        break;
    case _DB_VERSION:
        reply_xtra_db_version(desc, c);
        break;
    case _DB_CREATE:
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        if (find_unused_db_index(desc, &index) < 0) {
            reply_error(desc, ENOMEM);
        } else {
            desc->valmap_db[index] = c->o.db;
            reply_ok_valmap(desc, am_valmap_db, index);
        }
        break;
    case _DB_CLOSE:
        /* <hack place="ready_async-case-top" type="verbatim"> */

        /* 
        ** Quoting DB docs:
        ** "After DB->close has been called, regardless of its
        ** return, the DB handle may not be accessed again."
        */
        cleanup_valmap_db_index(desc, c->i.__valmap_db_index, 0);
 
        /* </hack --place="ready_async-case-top" type="verbatim"--> */
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        cleanup_valmap_db_index(desc, c->i.__valmap_db_index, 0);
        reply_ok_num(desc, c->o.ret_int);
        break;
    case _DB_DEL:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_FD:
        reply_xtra_db_fd(desc, c);
        break;
    case _DB_GET:
        reply_xtra_key_data(desc, c);
        break;
    case _DB_GET_BYTESWAPPED:
        reply_xtra_db_fd(desc, c);
        break;
    case _DB_GET_TYPE:
        reply_xtra_DBTYPE(desc, c);
        break;
    case _DB_OPEN:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_PUT:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_REMOVE:
        /* <hack place="ready_async-case-top" type="verbatim"> */

        /* 
        ** Quoting DB docs:
        ** "After DB->remove has been called, regardless of its
        ** return, the DB handle may not be accessed again."
        */
        cleanup_valmap_db_index(desc, c->i.__valmap_db_index, 0);
 
        /* </hack --place="ready_async-case-top" type="verbatim"--> */
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_RENAME:
        /* <hack place="ready_async-case-top" type="verbatim"> */

        /* 
        ** Quoting DB docs:
        ** "After DB->rename has been called, regardless of its
        ** return, the DB handle may not be accessed again."
        */
        cleanup_valmap_db_index(desc, c->i.__valmap_db_index, 0);
 
        /* </hack --place="ready_async-case-top" type="verbatim"--> */
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SYNC:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_TRUNCATE:
        reply_xtra_out_u_int32_t(desc, c);
        break;
    case _DB_UPGRADE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_VERIFY:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_CACHESIZE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_ERRFILE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_ERRPFX:
        reply_ok(desc);
        break;
    case _DB_SET_FLAGS:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_PAGESIZE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_BT_MINKEY:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_RE_DELIM:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_RE_LEN:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_RE_PAD:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_RE_SOURCE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_H_FFACTOR:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_H_NELEM:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_LORDER:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_SET_Q_EXTENTSIZE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _DB_CURSOR:
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        if (find_unused_cursor_index(desc, &index) < 0) {
            reply_error(desc, ENOMEM);
        } else {
            desc->valmap_cursor[index] = c->o.cursor;
            reply_ok_valmap(desc, am_valmap_cursor, index);
        }
        break;
    case _C_CLOSE:
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        cleanup_valmap_cursor_index(desc, c->i.__valmap_cursor_index, 0);
        reply_ok_num(desc, c->o.ret_int);
        break;
    case _C_COUNT:
        reply_xtra_out_u_int32_t(desc, c);
        break;
    case _C_DEL:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _C_GET:
        reply_xtra_key_data(desc, c);
        break;
    case _C_DUP:
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        if (find_unused_cursor_index(desc, &index) < 0) {
            reply_error(desc, ENOMEM);
        } else {
            desc->valmap_cursor[index] = c->o.cursor;
            reply_ok_valmap(desc, am_valmap_cursor, index);
        }
        break;
    case _C_PUT:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _SET_LK_CONFLICTS:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _SET_LK_DETECT:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _SET_LK_MAX_LOCKERS:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _SET_LK_MAX_LOCKS:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _SET_LK_MAX_OBJECTS:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _LOCK_DETECT:
        reply_xtra_out_int(desc, c);
        break;
    case _LOCK_ID:
        reply_xtra_out_u_int32_t(desc, c);
        break;
    case _LOCK_ID_FREE:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _LOCK_GET:
        reply_xtra_lock(desc, c);
        break;
    case _LOCK_PUT:
        if (c->o.__expect) {
            reply_ok_num(desc, c->o.ret_int);
        } else {
            reply_error(desc, c->o.__expect_errval);
        }
        break;
    case _TXN_ABORT:
        /* <hack place="ready_async-case-top" type="verbatim"> */

        /* 
        ** Quoting DB docs:
        ** "After DB_TXN->abort has been called, regardless of its
        ** return, the DB_TXN handle may not be accessed again."
        */
        cleanup_valmap_db_txn_index(desc, c->i.__valmap_db_txn_index, 0);
 
        /* </hack --place="ready_async-case-top" type="verbatim"--> */
        if (! c->o.__expect) {
            reply_error(desc, c->o.__expect_errval);
            break;
        }
        cleanup_valmap_db_txn_index(desc, c->i.__valmap_db_txn_index, 0);
        reply_ok_num(desc, c->o.ret_int);
        break;
    default:
        edtk_debug("%s: bogus command, should never happen", __FUNCTION__);
        break;
    }    
    for (i = 0; i < c->refc_bincount; i++) {
        driver_free_binary(c->refc_bin[i]);
    }
    sys_free(c);
}

static void
invoke__null(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    null(
                        );
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_create(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.dbenv = my_db_env_create(
                          c->i.flags, 
                         & c->o.my_error_value
                        );
    if (c->o.dbenv != NULL) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.my_error_value;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_close(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = my_db_env_close(
                          c->i.dbenv
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_open(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->open(
                          c->i.dbenv, 
                          c->i.db_home, 
                          c->i.flags, 
                          c->i.mode
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_remove(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->remove(
                          c->i.dbenv, 
                          c->i.db_home, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_data_dir(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_data_dir(
                          c->i.dbenv, 
                          c->i.dir
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_errfile(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = my_env_set_errfile(
                          c->i.dbenv, 
                          c->i.file, 
                          c->i.fopen_mode
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_errpfx(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->i.dbenv->set_errpfx(
                          c->i.dbenv, 
                          c->i.errpfx
                        );
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_flags(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_flags(
                          c->i.dbenv, 
                          c->i.flags, 
                          c->i.onoff
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_rpc_server(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_rpc_server(
                          c->i.dbenv, 
                          c->i.client, 
                          c->i.host, 
                          c->i.cl_timeout, 
                          c->i.sv_timeout, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_shm_key(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_shm_key(
                          c->i.dbenv, 
                          c->i.shm_key
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_tas_spins(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_tas_spins(
                          c->i.dbenv, 
                          c->i.tas_spins
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_tmp_dir(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_tmp_dir(
                          c->i.dbenv, 
                          c->i.dir
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_timeout(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_timeout(
                          c->i.dbenv, 
                          c->i.timeout, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__env_set_verbose(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_verbose(
                          c->i.dbenv, 
                          c->i.flags, 
                          c->i.onoff
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_strerror(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_char_p = db_strerror(
                          c->i.error
                        );
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_version(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_char_p = db_version(
                         & c->o.major, 
                         & c->o.minor, 
                         & c->o.patch
                        );
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_create(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.db = my_db_create(
                          c->i.dbenv, 
                          c->i.flags, 
                         & c->o.my_error_value
                        );
    if (c->o.db != NULL) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.my_error_value;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_close(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = my_db_close(
                          c->i.db
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_del(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->del(
                          c->i.db, 
                          c->i.txnid, 
                         & c->i.key_in, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    if (c->i.__valmap_db_txn_index >= 0) {
        c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        if (c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_txn_index(c->desc, c->i.__valmap_db_txn_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_fd(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->fd(
                          c->i.db, 
                         & c->o.fd
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_get(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->get(
                          c->i.db, 
                          c->i.txnid, 
                         & c->i.key_in, 
                         & c->i.data_in, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    if (c->i.__valmap_db_txn_index >= 0) {
        c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        if (c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_txn_index(c->desc, c->i.__valmap_db_txn_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_get_byteswapped(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->get_byteswapped(
                          c->i.db, 
                         & c->o.fd
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_get_type(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->get_type(
                          c->i.db, 
                         & c->o.type
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_open(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->open(
                          c->i.db, 
                          c->i.file, 
                          c->i.database, 
                          c->i.type, 
                          c->i.flags, 
                          c->i.mode
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_put(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->put(
                          c->i.db, 
                          c->i.txnid, 
                         & c->i.key_in, 
                         & c->i.data_in, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    if (c->i.__valmap_db_txn_index >= 0) {
        c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        if (c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_txn_index(c->desc, c->i.__valmap_db_txn_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_remove(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->remove(
                          c->i.db, 
                          c->i.file, 
                          c->i.database, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_rename(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->rename(
                          c->i.db, 
                          c->i.file, 
                          c->i.database, 
                          c->i.newname, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_sync(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->sync(
                          c->i.db, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_truncate(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->truncate(
                          c->i.db, 
                          c->i.txnid, 
                         & c->o.out_u_int32_t, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    if (c->i.__valmap_db_txn_index >= 0) {
        c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        if (c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_txn_index(c->desc, c->i.__valmap_db_txn_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_upgrade(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->upgrade(
                          c->i.db, 
                          c->i.file, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_verify(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = my_db_verify(
                          c->i.db, 
                          c->i.file, 
                          c->i.database, 
                          c->i.outfile, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_cachesize(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_cachesize(
                          c->i.db, 
                          c->i.gbytes, 
                          c->i.bytes, 
                          c->i.ncache
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_errfile(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = my_db_set_errfile(
                          c->i.db, 
                          c->i.file, 
                          c->i.fopen_mode
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_errpfx(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->i.db->set_errpfx(
                          c->i.db, 
                          c->i.errpfx
                        );
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_flags(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_flags(
                          c->i.db, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_pagesize(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_pagesize(
                          c->i.db, 
                          c->i.pagesize
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_bt_minkey(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_bt_minkey(
                          c->i.db, 
                          c->i.bt_minkey
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_re_delim(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_re_delim(
                          c->i.db, 
                          c->i.re_delim
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_re_len(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_re_len(
                          c->i.db, 
                          c->i.re_len
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_re_pad(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_re_pad(
                          c->i.db, 
                          c->i.re_pad
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_re_source(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_re_source(
                          c->i.db, 
                          c->i.re_source
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_h_ffactor(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_h_ffactor(
                          c->i.db, 
                          c->i.h_ffactor
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_h_nelem(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_h_nelem(
                          c->i.db, 
                          c->i.h_nelem
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_lorder(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_lorder(
                          c->i.db, 
                          c->i.lorder
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_set_q_extentsize(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db->set_q_extentsize(
                          c->i.db, 
                          c->i.extentsize
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__db_cursor(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.cursor = my_cursor_create(
                          c->i.db, 
                          c->i.txnid, 
                          c->i.flags, 
                         & c->o.my_error_value
                        );
    if (c->o.cursor != NULL) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.my_error_value;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_index >= 0) {
        c->desc->valmap_db_flags[c->i.__valmap_db_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_index, c->desc->valmap_db_flags[c->i.__valmap_db_index]);
        if (c->desc->valmap_db_flags[c->i.__valmap_db_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_index(c->desc, c->i.__valmap_db_index, 1);
        }
    }
    if (c->i.__valmap_db_txn_index >= 0) {
        c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        if (c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_txn_index(c->desc, c->i.__valmap_db_txn_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__c_close(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbc->c_close(
                          c->i.dbc
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_cursor_index >= 0) {
        c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        if (c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_cursor_index(c->desc, c->i.__valmap_cursor_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__c_count(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbc->c_count(
                          c->i.dbc, 
                         & c->o.out_u_int32_t, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_cursor_index >= 0) {
        c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        if (c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_cursor_index(c->desc, c->i.__valmap_cursor_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__c_del(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbc->c_del(
                          c->i.dbc, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_cursor_index >= 0) {
        c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        if (c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_cursor_index(c->desc, c->i.__valmap_cursor_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__c_get(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbc->c_get(
                          c->i.dbc, 
                         & c->i.key_in, 
                         & c->i.data_in, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_cursor_index >= 0) {
        c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        if (c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_cursor_index(c->desc, c->i.__valmap_cursor_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__c_dup(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.cursor = my_cursor_dup(
                          c->i.dbc, 
                          c->i.flags, 
                         & c->o.my_error_value
                        );
    if (c->o.cursor != NULL) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.my_error_value;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_cursor_index >= 0) {
        c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        if (c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_cursor_index(c->desc, c->i.__valmap_cursor_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__c_put(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbc->c_put(
                          c->i.dbc, 
                         & c->i.key_in, 
                         & c->i.data_in, 
                          c->i.flags
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_cursor_index >= 0) {
        c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_cursor_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_cursor_index, c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index]);
        if (c->desc->valmap_cursor_flags[c->i.__valmap_cursor_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_cursor_index(c->desc, c->i.__valmap_cursor_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__set_lk_conflicts(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_lk_conflicts(
                          c->i.dbenv, 
                          c->i.conflicts, 
                          c->i.nmodes
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__set_lk_detect(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_lk_detect(
                          c->i.dbenv, 
                          c->i.detect
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__set_lk_max_lockers(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_lk_max_lockers(
                          c->i.dbenv, 
                          c->i.max
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__set_lk_max_locks(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_lk_max_locks(
                          c->i.dbenv, 
                          c->i.max
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__set_lk_max_objects(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->set_lk_max_objects(
                          c->i.dbenv, 
                          c->i.max
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__lock_detect(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->lock_detect(
                          c->i.dbenv, 
                          c->i.flags, 
                          c->i.atype, 
                         & c->o.out_int
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__lock_id(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->lock_id(
                          c->i.dbenv, 
                         & c->o.out_u_int32_t
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__lock_id_free(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->lock_id_free(
                          c->i.dbenv, 
                          c->i.id
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__lock_get(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->lock_get(
                          c->i.dbenv, 
                          c->i.locker, 
                          c->i.flags, 
                         & c->i.obj, 
                          c->i.lock_mode, 
                         & c->o.lock
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__lock_put(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.dbenv->lock_put(
                          c->i.dbenv, 
                         & c->i.lock
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_dbenv_index >= 0) {
        c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_dbenv_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_dbenv_index, c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index]);
        if (c->desc->valmap_dbenv_flags[c->i.__valmap_dbenv_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_dbenv_index(c->desc, c->i.__valmap_dbenv_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}

static void
invoke__txn_abort(void *data)
{
    callstate_t *c = (callstate_t *) data;

    c = c;
    edtk_debug("%s: threadid = %lx", __FUNCTION__, pthread_self());
    c->o.ret_int = c->i.db_txn->abort(
                          c->i.db_txn
                        );
    if (c->o.ret_int == 0) {
        c->o.__expect = 1;
    } else {
        c->o.__expect = 0;
        c->o.__expect_errval = c->o.ret_int;
        /* Danger!  Do not put debugging statement before saving error val! */
        edtk_debug("%s: threadid = %lx expectation failed!", __FUNCTION__, pthread_self());
    }
    /* Begin valmap flag adjustment */
    pthread_mutex_lock(&c->desc->mutex);
    if (c->i.__valmap_db_txn_index >= 0) {
        c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] &= (~VALMAP_INUSE);
        edtk_debug("%s: INUSE cleared, c->desc->valmap_db_txn_flags[%d] = %d\r\n", __FUNCTION__, c->i.__valmap_db_txn_index, c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index]);
        if (c->desc->valmap_db_txn_flags[c->i.__valmap_db_txn_index] & VALMAP_DELAYED_CLEANUP) {
            cleanup_valmap_db_txn_index(c->desc, c->i.__valmap_db_txn_index, 1);
        }
    }
    pthread_mutex_unlock(&c->desc->mutex);
    /* End valmap flag adjustment */
    edtk_debug("%s: threadid = %lx done", __FUNCTION__, pthread_self());
}


static int
reply_ok(descriptor_t *desc)
{
    ErlDrvTermData      msg[24];
    int                 i = 0;
    int                 res;

    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_ATOM(msg, i, am_ok);
    i = LOAD_TUPLE(msg, i, 2);
    edtk_debug("reply_ok: i = %d", i);
    res = driver_output_term(desc->port, msg, i);
    edtk_debug("reply_ok: res = %d", res);
    return res;
}

static int
reply_ok_num(descriptor_t *desc, unsigned long num)
{
    ErlDrvTermData      msg[24];
    int                 i = 0;
    int                 res;

    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_ATOM(msg, i, am_ok);
    i = LOAD_INT(msg, i, num);
    i = LOAD_TUPLE(msg, i, 3);
    edtk_debug("%s: i = %d, num = %lu", __FUNCTION__, i, num);
    res = driver_output_term(desc->port, msg, i);
    edtk_debug("%s: res = %d", __FUNCTION__, res);
    return res;
}

static int
reply_ok_binary(descriptor_t *desc, char *ptr, int beg_offset, int length)
{
    ErlDrvTermData      msg[24];
    int                 i = 0;
    int                 res;

    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_ATOM(msg, i, am_ok);
    i = LOAD_BINARY(msg, i, edtk_alloced_ptr2ErlDrvBinary(ptr),
                    beg_offset, length);
    i = LOAD_TUPLE(msg, i, 3);
    edtk_debug("%s: i = %d, ptr = 0x%lx, start = %d, end = %d",
    __FUNCTION__, i, ptr, beg_offset, length);
    res = driver_output_term(desc->port, msg, i);
    /* driver_output_term() incrs refc, and we're done, so decr refc */
    /*
    ** We _know_ that "ptr" points to memory allocated by
    ** edtk_driver_alloc_wrapper(), so edtk_alloced_ptr2ErlDrvBinary()
    ** is safe in this case.  If it weren't safe, then the binary
    ** must be returned by an xtra_return, which means we
    ** reply_ok_binary()) are never called!
    */
    driver_free_binary(edtk_alloced_ptr2ErlDrvBinary(ptr));
    edtk_debug("%s: res = %d", __FUNCTION__, res);
    return res;
}

static int
reply_ok_valmap(descriptor_t *desc, ErlDrvTermData valmap_atom,
                unsigned long valmap_index)
{
    ErlDrvTermData      msg[15];
    int                 i = 0;
    int                 res;

    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_ATOM(msg, i, am_ok);
    i = LOAD_ATOM(msg, i, valmap_atom);
    i = LOAD_INT(msg, i, valmap_index);
    i = LOAD_TUPLE(msg, i, 2);
    i = LOAD_TUPLE(msg, i, 3);
    edtk_debug("reply_ok_valmap: i = %d", i);
    res = driver_output_term(desc->port, msg, i);
    edtk_debug("reply_ok_valmap: res = %d", res);
    return res;
}

static int
reply_error(descriptor_t *desc, int errnum)
{
    ErlDrvTermData      msg[24];
    int                 i = 0;
    int                 res;

    edtk_debug("reply_error: errnum = %d", errnum);
    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_ATOM(msg, i, am_error);
    i = LOAD_INT(msg, i, errnum);
    i = LOAD_TUPLE(msg, i, 3);
    edtk_debug("reply_error: i = %d", i);
    res = driver_output_term(desc->port, msg, i);
    edtk_debug("reply_error: res = %d", res);
    return res;
}

static int
reply_error_atom(descriptor_t *desc, ErlDrvTermData atom)
{
    ErlDrvTermData      msg[24];
    int                 i = 0;
    int                 res;

    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_ATOM(msg, i, am_error);
    i = LOAD_ATOM(msg, i, atom);
    i = LOAD_TUPLE(msg, i, 3);
    edtk_debug("%s: i = %d", __FUNCTION__, i);
    res = driver_output_term(desc->port, msg, i);
    edtk_debug("%s: res = %d", __FUNCTION__, res);
    return res;
}

#if     0       /* XXX These are unused right now */
static int
reply_tag_ok(descriptor_t *desc, unsigned short tag)
{
    ErlDrvTermData      msg[24];
    int                 i = 0;
    int                 res;

    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_INT(msg, i, tag);
    i = LOAD_ATOM(msg, i, am_ok);
    i = LOAD_TUPLE(msg, i, 3);
    edtk_debug("reply_ok: i = %d", i);
    res = driver_output_term(desc->port, msg, i);
    edtk_debug("reply_ok: res = %d", res);
    return res;
}

static int
reply_tag_error(descriptor_t *desc, unsigned short tag, int errnum)
{
    ErlDrvTermData      msg[24];
    int                 i = 0;
    int                 res;

    edtk_debug("reply_error: errnum = %d", errnum);
    i = LOAD_PORT(msg, i, driver_mk_port(desc->port));
    i = LOAD_INT(msg, i, tag);
    i = LOAD_INT(msg, i, errnum);
    i = LOAD_ATOM(msg, i, am_error);
    i = LOAD_TUPLE(msg, i, 4);
    edtk_debug("reply_error: i = %d", i);
    res = driver_output_term(desc->port, msg, i);
    edtk_debug("reply_error: res = %d", res);
    return res;
}
#endif  /* 0 */


static int
reply_xtra_db_version(descriptor_t *desc, callstate_t *c)
{
    ErlDrvTermData      msg[MAX_RETURN_TERMS];
    int                 msgcount = 0;
    int                 res;
    int                 members = 0;
    char                *tmp = NULL;
    int                 i;
    ErlDrvBinary        *tmpbin = NULL;

    tmp = tmp; tmpbin = tmpbin;
    desc->num_tofree = 0;

    msgcount = LOAD_PORT(msg, msgcount, driver_mk_port(desc->port));
    members = 2;        /* members will be 2 very shortly: Port & ok|error */
    if (c->o.__expect) {
        msgcount = LOAD_ATOM(msg, msgcount, am_ok);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.major);
             members++;
             msgcount = LOAD_INT(msg, msgcount, c->o.minor);
             members++;
             msgcount = LOAD_INT(msg, msgcount, c->o.patch);
             members++;
             if ((tmp = edtk_driver_alloc_wrapper(strlen(c->o.ret_char_p))) == NULL) {
              return reply_error(desc, ENOMEM);
             }
             memcpy(tmp,  c->o.ret_char_p, strlen(c->o.ret_char_p));
             tmpbin = edtk_alloced_ptr2ErlDrvBinary(tmp);
             msgcount = LOAD_BINARY(msg, msgcount, tmpbin, 0, strlen(c->o.ret_char_p));
             /* driver_output_term() incrs refc, and we're done, so decr refc LATER */
             desc->tofree[desc->num_tofree++] = tmpbin;
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    } else {
        msgcount = LOAD_ATOM(msg, msgcount, am_error);
        {
            int members = 0;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    }
    msgcount = LOAD_TUPLE(msg, msgcount, 3);
    edtk_debug("reply_xtra_db_version: i = %d", msgcount);
    res = driver_output_term(desc->port, msg, msgcount);
    edtk_debug("reply_xtra_db_version: res = %d", res);
    if (res < 0) {
        fprintf(stderr, "\r\n\r\nreply_xtra_db_version: driver_output_term() failed!    This should never happen!\r\n\r\n");
    }

    for (i = 0; i < desc->num_tofree; i++) {
        driver_free_binary(desc->tofree[i]);
    }
    return res;
}

static int
reply_xtra_db_fd(descriptor_t *desc, callstate_t *c)
{
    ErlDrvTermData      msg[MAX_RETURN_TERMS];
    int                 msgcount = 0;
    int                 res;
    int                 members = 0;
    char                *tmp = NULL;
    int                 i;
    ErlDrvBinary        *tmpbin = NULL;

    tmp = tmp; tmpbin = tmpbin;
    desc->num_tofree = 0;

    msgcount = LOAD_PORT(msg, msgcount, driver_mk_port(desc->port));
    members = 2;        /* members will be 2 very shortly: Port & ok|error */
    if (c->o.__expect) {
        msgcount = LOAD_ATOM(msg, msgcount, am_ok);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.fd);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    } else {
        msgcount = LOAD_ATOM(msg, msgcount, am_error);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.ret_int);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    }
    msgcount = LOAD_TUPLE(msg, msgcount, 3);
    edtk_debug("reply_xtra_db_fd: i = %d", msgcount);
    res = driver_output_term(desc->port, msg, msgcount);
    edtk_debug("reply_xtra_db_fd: res = %d", res);
    if (res < 0) {
        fprintf(stderr, "\r\n\r\nreply_xtra_db_fd: driver_output_term() failed!         This should never happen!\r\n\r\n");
    }

    for (i = 0; i < desc->num_tofree; i++) {
        driver_free_binary(desc->tofree[i]);
    }
    return res;
}

static int
reply_xtra_DBTYPE(descriptor_t *desc, callstate_t *c)
{
    ErlDrvTermData      msg[MAX_RETURN_TERMS];
    int                 msgcount = 0;
    int                 res;
    int                 members = 0;
    char                *tmp = NULL;
    int                 i;
    ErlDrvBinary        *tmpbin = NULL;

    tmp = tmp; tmpbin = tmpbin;
    desc->num_tofree = 0;

    msgcount = LOAD_PORT(msg, msgcount, driver_mk_port(desc->port));
    members = 2;        /* members will be 2 very shortly: Port & ok|error */
    if (c->o.__expect) {
        msgcount = LOAD_ATOM(msg, msgcount, am_ok);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.type);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    } else {
        msgcount = LOAD_ATOM(msg, msgcount, am_error);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.ret_int);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    }
    msgcount = LOAD_TUPLE(msg, msgcount, 3);
    edtk_debug("reply_xtra_DBTYPE: i = %d", msgcount);
    res = driver_output_term(desc->port, msg, msgcount);
    edtk_debug("reply_xtra_DBTYPE: res = %d", res);
    if (res < 0) {
        fprintf(stderr, "\r\n\r\nreply_xtra_DBTYPE: driver_output_term() failed!        This should never happen!\r\n\r\n");
    }

    for (i = 0; i < desc->num_tofree; i++) {
        driver_free_binary(desc->tofree[i]);
    }
    return res;
}

static int
reply_xtra_out_u_int32_t(descriptor_t *desc, callstate_t *c)
{
    ErlDrvTermData      msg[MAX_RETURN_TERMS];
    int                 msgcount = 0;
    int                 res;
    int                 members = 0;
    char                *tmp = NULL;
    int                 i;
    ErlDrvBinary        *tmpbin = NULL;

    tmp = tmp; tmpbin = tmpbin;
    desc->num_tofree = 0;

    msgcount = LOAD_PORT(msg, msgcount, driver_mk_port(desc->port));
    members = 2;        /* members will be 2 very shortly: Port & ok|error */
    if (c->o.__expect) {
        msgcount = LOAD_ATOM(msg, msgcount, am_ok);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.out_u_int32_t);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    } else {
        msgcount = LOAD_ATOM(msg, msgcount, am_error);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.ret_int);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    }
    msgcount = LOAD_TUPLE(msg, msgcount, 3);
    edtk_debug("reply_xtra_out_u_int32_t: i = %d", msgcount);
    res = driver_output_term(desc->port, msg, msgcount);
    edtk_debug("reply_xtra_out_u_int32_t: res = %d", res);
    if (res < 0) {
        fprintf(stderr, "\r\n\r\nreply_xtra_out_u_int32_t: driver_output_term() failed!  This should never happen!\r\n\r\n");
    }

    for (i = 0; i < desc->num_tofree; i++) {
        driver_free_binary(desc->tofree[i]);
    }
    return res;
}

static int
reply_xtra_out_int(descriptor_t *desc, callstate_t *c)
{
    ErlDrvTermData      msg[MAX_RETURN_TERMS];
    int                 msgcount = 0;
    int                 res;
    int                 members = 0;
    char                *tmp = NULL;
    int                 i;
    ErlDrvBinary        *tmpbin = NULL;

    tmp = tmp; tmpbin = tmpbin;
    desc->num_tofree = 0;

    msgcount = LOAD_PORT(msg, msgcount, driver_mk_port(desc->port));
    members = 2;        /* members will be 2 very shortly: Port & ok|error */
    if (c->o.__expect) {
        msgcount = LOAD_ATOM(msg, msgcount, am_ok);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.out_int);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    } else {
        msgcount = LOAD_ATOM(msg, msgcount, am_error);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.ret_int);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    }
    msgcount = LOAD_TUPLE(msg, msgcount, 3);
    edtk_debug("reply_xtra_out_int: i = %d", msgcount);
    res = driver_output_term(desc->port, msg, msgcount);
    edtk_debug("reply_xtra_out_int: res = %d", res);
    if (res < 0) {
        fprintf(stderr, "\r\n\r\nreply_xtra_out_int: driver_output_term() failed!       This should never happen!\r\n\r\n");
    }

    for (i = 0; i < desc->num_tofree; i++) {
        driver_free_binary(desc->tofree[i]);
    }
    return res;
}

static int
reply_xtra_key_data(descriptor_t *desc, callstate_t *c)
{
    ErlDrvTermData      msg[MAX_RETURN_TERMS];
    int                 msgcount = 0;
    int                 res;
    int                 members = 0;
    char                *tmp = NULL;
    int                 i;
    ErlDrvBinary        *tmpbin = NULL;

    tmp = tmp; tmpbin = tmpbin;
    desc->num_tofree = 0;

    msgcount = LOAD_PORT(msg, msgcount, driver_mk_port(desc->port));
    members = 2;        /* members will be 2 very shortly: Port & ok|error */
    if (c->o.__expect) {
        msgcount = LOAD_ATOM(msg, msgcount, am_ok);
        {
            int members = 0;
             { /* A single term of any type, use when custom handling required */
                 int members = 0;
                 
                 make_dbt_key(desc, c, msg, &members, &msgcount);
                 if (members != 1) { fprintf(stderr, "\r\n\r\nXXX xtra_return: term maker returned members = %d!  This should never happen!\r\n\r\n", members); }
             }
             members++;
             { /* A single term of any type, use when custom handling required */
                 int members = 0;
                 
                 make_dbt_data(desc, c, msg, &members, &msgcount);
                 if (members != 1) { fprintf(stderr, "\r\n\r\nXXX xtra_return: term maker returned members = %d!  This should never happen!\r\n\r\n", members); }
             }
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    } else {
        msgcount = LOAD_ATOM(msg, msgcount, am_error);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.ret_int);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    }
    msgcount = LOAD_TUPLE(msg, msgcount, 3);
    edtk_debug("reply_xtra_key_data: i = %d", msgcount);
    res = driver_output_term(desc->port, msg, msgcount);
    edtk_debug("reply_xtra_key_data: res = %d", res);
    if (res < 0) {
        fprintf(stderr, "\r\n\r\nreply_xtra_key_data: driver_output_term() failed!      This should never happen!\r\n\r\n");
    }

    for (i = 0; i < desc->num_tofree; i++) {
        driver_free_binary(desc->tofree[i]);
    }
    return res;
}

static int
reply_xtra_lock(descriptor_t *desc, callstate_t *c)
{
    ErlDrvTermData      msg[MAX_RETURN_TERMS];
    int                 msgcount = 0;
    int                 res;
    int                 members = 0;
    char                *tmp = NULL;
    int                 i;
    ErlDrvBinary        *tmpbin = NULL;

    tmp = tmp; tmpbin = tmpbin;
    desc->num_tofree = 0;

    msgcount = LOAD_PORT(msg, msgcount, driver_mk_port(desc->port));
    members = 2;        /* members will be 2 very shortly: Port & ok|error */
    if (c->o.__expect) {
        msgcount = LOAD_ATOM(msg, msgcount, am_ok);
        {
            int members = 0;
             if ((tmp = edtk_driver_alloc_wrapper(sizeof(DB_LOCK))) == NULL) {
              return reply_error(desc, ENOMEM);
             }
             memcpy(tmp, & c->o.lock, sizeof(DB_LOCK));
             tmpbin = edtk_alloced_ptr2ErlDrvBinary(tmp);
             msgcount = LOAD_BINARY(msg, msgcount, tmpbin, 0, sizeof(DB_LOCK));
             /* driver_output_term() incrs refc, and we're done, so decr refc LATER */
             desc->tofree[desc->num_tofree++] = tmpbin;
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    } else {
        msgcount = LOAD_ATOM(msg, msgcount, am_error);
        {
            int members = 0;
             msgcount = LOAD_INT(msg, msgcount, c->o.ret_int);
             members++;
            msgcount = LOAD_TUPLE(msg, msgcount, members);
        }
    }
    msgcount = LOAD_TUPLE(msg, msgcount, 3);
    edtk_debug("reply_xtra_lock: i = %d", msgcount);
    res = driver_output_term(desc->port, msg, msgcount);
    edtk_debug("reply_xtra_lock: res = %d", res);
    if (res < 0) {
        fprintf(stderr, "\r\n\r\nreply_xtra_lock: driver_output_term() failed!          This should never happen!\r\n\r\n");
    }

    for (i = 0; i < desc->num_tofree; i++) {
        driver_free_binary(desc->tofree[i]);
    }
    return res;
}


static int
find_unused_cursor_index(descriptor_t *desc, unsigned long *index_p)
{
    int i;

    for (i = 0; i < 32; i++) {
        if (desc->valmap_cursor[i] == NULL) {
            *index_p = i;
            return 0;
        }
    }
    return -1;
}

static void
cleanup_valmap_cursor_index(descriptor_t *desc, int i, int do_cleanup_func)
{
    edtk_debug("%s: i = %d, do_cleanup_func = %d", __FUNCTION__, i, do_cleanup_func);
    pthread_mutex_lock(&desc->mutex);
    if (desc->valmap_cursor_flags[i] & VALMAP_INUSE) {
        edtk_debug("%s: i = %d, in use, setting VALMAP_DELAYED_CLEANUP flag", __FUNCTION__, i);
        desc->valmap_cursor_flags[i] |= VALMAP_DELAYED_CLEANUP;
        pthread_mutex_unlock(&desc->mutex);
        return;
    }
    desc->valmap_cursor_flags[i] = 0;
    pthread_mutex_unlock(&desc->mutex);
    if (do_cleanup_func) {
        edtk_debug("%s: calling func my_cursor_close", __FUNCTION__);
        my_cursor_close(desc->valmap_cursor[i]);
    }
    desc->valmap_cursor[i] = NULL;
}

static void
cleanup_valmap_cursor_all(descriptor_t *desc, int do_cleanup_func)
{
    int i;

    edtk_debug("%s: do_cleanup_func = %d", __FUNCTION__, do_cleanup_func);
    for (i = 0; i < 32; i++) {
        cleanup_valmap_cursor_index(desc, i, do_cleanup_func);
    }
}

static int
find_unused_db_txn_index(descriptor_t *desc, unsigned long *index_p)
{
    int i;

    for (i = 0; i < 32; i++) {
        if (desc->valmap_db_txn[i] == NULL) {
            *index_p = i;
            return 0;
        }
    }
    return -1;
}

static void
cleanup_valmap_db_txn_index(descriptor_t *desc, int i, int do_cleanup_func)
{
    edtk_debug("%s: i = %d, do_cleanup_func = %d", __FUNCTION__, i, do_cleanup_func);
    pthread_mutex_lock(&desc->mutex);
    if (desc->valmap_db_txn_flags[i] & VALMAP_INUSE) {
        edtk_debug("%s: i = %d, in use, setting VALMAP_DELAYED_CLEANUP flag", __FUNCTION__, i);
        desc->valmap_db_txn_flags[i] |= VALMAP_DELAYED_CLEANUP;
        pthread_mutex_unlock(&desc->mutex);
        return;
    }
    desc->valmap_db_txn_flags[i] = 0;
    pthread_mutex_unlock(&desc->mutex);
    if (do_cleanup_func) {
        edtk_debug("%s: calling func my_txn_abort", __FUNCTION__);
        my_txn_abort(desc->valmap_db_txn[i]);
    }
    desc->valmap_db_txn[i] = NULL;
}

static void
cleanup_valmap_db_txn_all(descriptor_t *desc, int do_cleanup_func)
{
    int i;

    edtk_debug("%s: do_cleanup_func = %d", __FUNCTION__, do_cleanup_func);
    for (i = 0; i < 32; i++) {
        cleanup_valmap_db_txn_index(desc, i, do_cleanup_func);
    }
}

static int
find_unused_db_index(descriptor_t *desc, unsigned long *index_p)
{
    int i;

    for (i = 0; i < 32; i++) {
        if (desc->valmap_db[i] == NULL) {
            *index_p = i;
            return 0;
        }
    }
    return -1;
}

static void
cleanup_valmap_db_index(descriptor_t *desc, int i, int do_cleanup_func)
{
    edtk_debug("%s: i = %d, do_cleanup_func = %d", __FUNCTION__, i, do_cleanup_func);
    pthread_mutex_lock(&desc->mutex);
    if (desc->valmap_db_flags[i] & VALMAP_INUSE) {
        edtk_debug("%s: i = %d, in use, setting VALMAP_DELAYED_CLEANUP flag", __FUNCTION__, i);
        desc->valmap_db_flags[i] |= VALMAP_DELAYED_CLEANUP;
        pthread_mutex_unlock(&desc->mutex);
        return;
    }
    desc->valmap_db_flags[i] = 0;
    pthread_mutex_unlock(&desc->mutex);
    if (do_cleanup_func) {
        edtk_debug("%s: calling func my_db_close", __FUNCTION__);
        my_db_close(desc->valmap_db[i]);
    }
    desc->valmap_db[i] = NULL;
}

static void
cleanup_valmap_db_all(descriptor_t *desc, int do_cleanup_func)
{
    int i;

    edtk_debug("%s: do_cleanup_func = %d", __FUNCTION__, do_cleanup_func);
    for (i = 0; i < 32; i++) {
        cleanup_valmap_db_index(desc, i, do_cleanup_func);
    }
}

static int
find_unused_dbenv_index(descriptor_t *desc, unsigned long *index_p)
{
    int i;

    for (i = 0; i < 1; i++) {
        if (desc->valmap_dbenv[i] == NULL) {
            *index_p = i;
            return 0;
        }
    }
    return -1;
}

static void
cleanup_valmap_dbenv_index(descriptor_t *desc, int i, int do_cleanup_func)
{
    edtk_debug("%s: i = %d, do_cleanup_func = %d", __FUNCTION__, i, do_cleanup_func);
    pthread_mutex_lock(&desc->mutex);
    if (desc->valmap_dbenv_flags[i] & VALMAP_INUSE) {
        edtk_debug("%s: i = %d, in use, setting VALMAP_DELAYED_CLEANUP flag", __FUNCTION__, i);
        desc->valmap_dbenv_flags[i] |= VALMAP_DELAYED_CLEANUP;
        pthread_mutex_unlock(&desc->mutex);
        return;
    }
    desc->valmap_dbenv_flags[i] = 0;
    pthread_mutex_unlock(&desc->mutex);
    if (do_cleanup_func) {
        edtk_debug("%s: calling func my_db_env_close", __FUNCTION__);
        my_db_env_close(desc->valmap_dbenv[i]);
    }
    desc->valmap_dbenv[i] = NULL;
}

static void
cleanup_valmap_dbenv_all(descriptor_t *desc, int do_cleanup_func)
{
    int i;

    edtk_debug("%s: do_cleanup_func = %d", __FUNCTION__, do_cleanup_func);
    for (i = 0; i < 1; i++) {
        cleanup_valmap_dbenv_index(desc, i, do_cleanup_func);
    }
}


